## pdqmlwidgets2 0.0.1.61.ge0b6150

=== CMakeLists.txt ===
#-----------------------------------------------------------------------------
#
# Copyright (C) 2022 Bjarne von Horn <vh@igh.de>
#
# This file is part of the PdQmlWidgets library.
#
# The PdQmlWidgets library is free software: you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public License as
# published by the Free Software Foundation, either version 3 of the License,
# or (at your option) any later version.
#
# The PdQmlWidgets library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser
# General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with the PdQmlWidgets Library. If not, see
# <http://www.gnu.org/licenses/>.
#
#-----------------------------------------------------------------------------

cmake_minimum_required(VERSION 3.10)

project(PdQmlWidgets2 VERSION 2.0.0)

include(CMakePackageConfigHelpers)
include(GNUInstallDirs)

option(BUILD_SHARED_LIBS "Build using shared libraries" ON)
option(BUILD_EXAMPLE "Build and install example" OFF)

set(PUBLIC_QT_COMPONENTS Core Quick)

set(PRIVATE_QT_COMPONENTS Qml Svg Xml)
find_package(QtPdCom1 REQUIRED)
find_package(Qt5 REQUIRED
    COMPONENTS ${PUBLIC_QT_COMPONENTS} ${PRIVATE_QT_COMPONENTS}
)

find_package(Qt5
    OPTIONAL_COMPONENTS QuickCompiler
)

set(QRC_FILES
    qml/de/igh/pd/de_igh_pdQmlWidgets.qrc
)

set(USED_QTQUICK_COMPILER 0)

# compile qml files if possible, else add them to rc file as they are.
if(COMMAND qtquick_compiler_add_resources)
    qtquick_compiler_add_resources(RCC_SOURCES ${QRC_FILES})
    set(USED_QTQUICK_COMPILER 1)
else()
    qt5_add_resources(RCC_SOURCES ${QRC_FILES})
endif()

add_library(${PROJECT_NAME}
    PdQmlWidgets2/LiveSvg.h
    PdQmlWidgets2/ScalarVariant.h
    PdQmlWidgets2/VectorVariant.h
    PdQmlWidgets2/PdQmlWidgets2.h

    src/LiveSvg.cpp
    src/PdQmlWidgets2.cpp
    src/ScalarVariant.cpp
    src/VectorVariant.cpp

    ${RCC_SOURCES}
)

target_include_directories(${PROJECT_NAME} PUBLIC
    "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>"
    "$<INSTALL_INTERFACE:include>"
)

target_link_libraries(${PROJECT_NAME}
    PUBLIC
        EtherLab::QtPdCom1
        Qt5::Core
        Qt5::Quick
    PRIVATE
        Qt5::Qml
        Qt5::Svg
        Qt5::Xml
)

if (USED_QTQUICK_COMPILER)
    # Q_INIT_RESOURCE needs to know the qrc name
    # which changes when QtQuick Compiler is used
    target_compile_definitions(${PROJECT_NAME} PRIVATE "USED_QTQUICK_COMPILER")
endif()

set_target_properties(${PROJECT_NAME} PROPERTIES
    AUTOMOC 1
    AUTORCC 1
    VISIBILITY_INLINES_HIDDEN 1
    CXX_VISIBILITY_PRESET "hidden"
    VERSION ${PROJECT_VERSION}
    SOVERSION 2
)

# and install it
install(TARGETS ${PROJECT_NAME}
    EXPORT ${PROJECT_NAME}Targets
    ARCHIVE DESTINATION       "${CMAKE_INSTALL_LIBDIR}"
    LIBRARY DESTINATION       "${CMAKE_INSTALL_LIBDIR}"
    RUNTIME DESTINATION       "${CMAKE_INSTALL_BINDIR}"
)

install(DIRECTORY ${PROJECT_NAME} DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}")

# and export it

set(ConfigPackageLocation "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}")
configure_package_config_file(Config.cmake.in
        "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}/${PROJECT_NAME}Config.cmake"
    INSTALL_DESTINATION ${ConfigPackageLocation}
)
write_basic_package_version_file(
        "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}/${PROJECT_NAME}ConfigVersion.cmake"
    COMPATIBILITY SameMajorVersion
)
install(FILES
        "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}/${PROJECT_NAME}Config.cmake"
        "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}/${PROJECT_NAME}ConfigVersion.cmake"
    DESTINATION ${ConfigPackageLocation}
)

install(EXPORT ${PROJECT_NAME}Targets
    NAMESPACE EtherLab::
    FILE ${PROJECT_NAME}Targets.cmake
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}
)

export(EXPORT ${PROJECT_NAME}Targets
    FILE "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}/${PROJECT_NAME}Targets.cmake"
    NAMESPACE EtherLab::
)

## Install qml files

add_subdirectory(qml/de/igh/pd)

## Build example (optionally)

if (BUILD_EXAMPLE)
    add_library(EtherLab::PdQmlWidgets2 ALIAS PdQmlWidgets2)
    add_subdirectory(qml_test)
endif()

=== qml_test/CMakeLists.txt ===
#-----------------------------------------------------------------------------
#
# Copyright (C) 2022 Bjarne von Horn <vh@igh.de>
#
# This file is part of the PdQmlWidgets library.
#
# The PdQmlWidgets library is free software: you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public License as
# published by the Free Software Foundation, either version 3 of the License,
# or (at your option) any later version.
#
# The PdQmlWidgets library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser
# General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with the PdQmlWidgets Library. If not, see
# <http://www.gnu.org/licenses/>.
#
#-----------------------------------------------------------------------------

cmake_minimum_required(VERSION 3.10)

project(QmlTest)
include(GNUInstallDirs)

# load Qt
find_package(Qt5 REQUIRED
    COMPONENTS Charts Gui Quick QuickControls2 Svg Xml
)
find_package(Qt5
    OPTIONAL_COMPONENTS QuickCompiler
)
# load Widgets with QML files
if (NOT TARGET EtherLab::PdQmlWidgets2)
    find_package(PdQmlWidgets2 REQUIRED)
endif()

# compile qml files (of this project) if compiler available
if(COMMAND qtquick_compiler_add_resources)
    qtquick_compiler_add_resources(EXAMPLE_RCC_SOURCES resources.qrc)
else()
    qt5_add_resources(EXAMPLE_RCC_SOURCES resources.qrc)
endif()

set(SOURCES
    src/ScalarSeries.h
    src/QmlBuddy.h
    src/ScalarSeries.cpp
    src/QmlBuddy.cpp
    src/main.cpp

    ${EXAMPLE_RCC_SOURCES}
)

add_executable(${PROJECT_NAME} ${SOURCES})

set_target_properties(${PROJECT_NAME} PROPERTIES
    AUTOUIC 0
    AUTOMOC 1
    AUTORCC 0
)

# link in Qt, the PdWidgets and the PdWidgets QML files

target_link_libraries(${PROJECT_NAME} PUBLIC
    EtherLab::PdQmlWidgets2
    Qt5::Charts
    Qt5::Quick
    Qt5::QuickControls2
)

install(TARGETS ${PROJECT_NAME}
    ARCHIVE DESTINATION       "${CMAKE_INSTALL_LIBDIR}"
    LIBRARY DESTINATION       "${CMAKE_INSTALL_LIBDIR}"
    RUNTIME DESTINATION       "${CMAKE_INSTALL_BINDIR}"
)

=== qml/de/igh/pd/CMakeLists.txt ===
if(NOT QML_DIR)
    set(QML_DIR "${CMAKE_INSTALL_LIBDIR}/qt5/qml")
endif()
set(QML_PATH "de/igh/pd.2")

install(FILES
    de_igh_pdQmlWidgets.pri
    de_igh_pdQmlWidgets.qrc
    FontAwesome.otf
    qmldir
    Sprintf.js
    PdBar.qml
    PdCheckBox.qml
    PdComboBox.qml
    PdDigital.qml
    PdVectorDigital.qml
    PdLabel.qml
    PdText.qml
    PdImage.qml
    PdLed.qml
    PdMultiLed.qml
    PdPushButton.qml
    PdToolButton.qml
    PdButton.qml
    PdSwitch.qml
    PdStatusIndicator.qml
    PdSlider.qml
    PdTimeLabel.qml
    PdVectorLed.qml
    PdTouchEdit.qml
    TouchEdit.qml
    TouchEdit_2_1.qml
    TouchEditDialog.qml
DESTINATION "${QML_DIR}/${QML_PATH}")

install(DIRECTORY
    +material
    quick1
    style
DESTINATION "${QML_DIR}/${QML_PATH}")

=== debian/changelog ===
pdqmlwidgets2 (0.0.1.61.ge0b6150-0) UNRELEASED; urgency=medium

   * Initial, First build

 -- Bjarne von Horn <vh@igh.de>  Mon, 24 Jan 2022 16:14:57 +0100

=== debian/rules ===
#!/usr/bin/make -f

export QT_SELECT := qt5

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#DH_VERBOSE = 1

# see EXAMPLES in dpkg-buildflags(1) and read /usr/share/dpkg/*
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

# see FEATURE AREAS in dpkg-buildflags(1)
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed


%:
	dh $@ --parallel


.PHONY:
	override_dh_strip

override_dh_strip:
	dh_strip --dbg-package=libpdqmlwidgets2-dbg

override_dh_missing:
	dh_missing --fail-missing

override_dh_shlibdeps:
	dh_shlibdeps -l $(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/

## pdqmlwidgets2 0.0.1.109.g95c435e

=== debian/changelog ===
pdqmlwidgets2 (0.0.1.109.g95c435e-0) UNRELEASED; urgency=medium

   * Initial, First build

 -- Bjarne von Horn <vh@igh.de>  Mon, 24 Jan 2022 16:14:57 +0100

=== debian/control ===
Source: pdqmlwidgets2
Priority: optional
Maintainer: Andreas Stewering-Bone <ab@igh.de>
Build-Depends: dh-exec (>= 0.3), debhelper (>= 9), qtchooser, qtbase5-dev, libqt5svg5-dev, qttools5-dev, qttools5-dev-tools, libqtpdcom1-dev, cmake (>= 3.10), qtdeclarative5-dev, qtdeclarative5-dev-tools
Standards-Version: 3.9.5
Section: libs
Homepage: http://www.etherlab.org

Package: libpdqmlwidgets2-dev
Section: libdevel
Architecture: any
Depends: libpdqmlwidgets2 (= ${binary:Version}), libqtpdcom1-dev, ${misc:Depends}
Description: Process data widgets for QML
 This is a bundle of QML-based process data widgets for Qt5. It uses the PdCom library to
 access the actual process variables and it includes a plugin for the Qt
 Designer. See http://etherlab.org/en/pdwidgets for more information.
 .
 Header files

Package: libpdqmlwidgets2
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Process data widgets for QML
 This is a bundle of QML-based process data widgets for Qt5. It uses the PdCom library to
 access the actual process variables and it includes a plugin for the Qt
 Designer. See http://etherlab.org/en/pdwidgets for more information.

Package: libpdqmlwidgets2-dbg
Architecture: any
Section: debug
Priority: extra
Depends: libpdqmlwidgets2 (= ${binary:Version}), ${misc:Depends}
Description: Process data widgets for QML
 This is a bundle of QML-based process data widgets for Qt5. It uses the PdCom library to
 access the actual process variables and it includes a plugin for the Qt
 Designer. See http://etherlab.org/en/pdwidgets for more information.
 .
 This package contains the debugging symbols for libppdqmlwidgets

## pdqmlwidgets2 0.0.2.g868d16f

=== CMakeLists.txt ===
--- 
+++ 
@@ -56,11 +56,12 @@
     qt5_add_resources(RCC_SOURCES ${QRC_FILES})
 endif()
 
+configure_file(PdQmlWidgets2.h.in "${CMAKE_CURRENT_BINARY_DIR}/PdQmlWidgets2/PdQmlWidgets2.h")
+
 add_library(${PROJECT_NAME}
     PdQmlWidgets2/LiveSvg.h
     PdQmlWidgets2/ScalarVariant.h
     PdQmlWidgets2/VectorVariant.h
-    PdQmlWidgets2/PdQmlWidgets2.h
 
     src/LiveSvg.cpp
     src/PdQmlWidgets2.cpp
@@ -72,6 +73,7 @@
 
 target_include_directories(${PROJECT_NAME} PUBLIC
     "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>"
+    "$<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>"
     "$<INSTALL_INTERFACE:include>"
 )
 
@@ -110,6 +112,9 @@
 )
 
 install(DIRECTORY ${PROJECT_NAME} DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}")
+install(FILES "${CMAKE_CURRENT_BINARY_DIR}/PdQmlWidgets2/PdQmlWidgets2.h"
+    DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/${PROJECT_NAME}"
+)
 
 # and export it
 
@@ -139,6 +144,30 @@
     NAMESPACE EtherLab::
 )
 
+## bake in git commit hash
+
+
+if (VERSION_HASH)
+    # Hash was given as option, so write it directly
+    # useful for OBS packaging
+    file(WRITE "${CMAKE_CURRENT_BINARY_DIR}/git_revision_hash.h"
+        "#define GIT_REV \"${VERSION_HASH}\"
+")
+else()
+    # recompute hash on every `make` invocation
+    # Note: CMake variable definitions (-D) must be before the -P option!
+    add_custom_target(GitRevision
+        BYPRODUCTS "${CMAKE_CURRENT_BINARY_DIR}/git_revision_hash.h"
+        COMMAND ${CMAKE_COMMAND}
+            -DSOURCE_DIR="${CMAKE_CURRENT_SOURCE_DIR}"
+            -DHASH_MACRO_NAME="GIT_REV"
+            -DTARGET_FILE="${CMAKE_CURRENT_BINARY_DIR}/git_revision_hash.h"
+            -P ${CMAKE_CURRENT_SOURCE_DIR}/git_revision.cmake
+    )
+    add_dependencies(${PROJECT_NAME} GitRevision)
+endif()
+
+
 ## Install qml files
 
 add_subdirectory(qml/de/igh/pd)
@@ -149,3 +178,5 @@
     add_library(EtherLab::PdQmlWidgets2 ALIAS PdQmlWidgets2)
     add_subdirectory(qml_test)
 endif()
+
+configure_file(Doxyfile.in "${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile" @ONLY)

=== qml_test/CMakeLists.txt ===
--- 
+++ 
@@ -46,9 +46,7 @@
 
 set(SOURCES
     src/ScalarSeries.h
-    src/QmlBuddy.h
     src/ScalarSeries.cpp
-    src/QmlBuddy.cpp
     src/main.cpp
 
     ${EXAMPLE_RCC_SOURCES}
@@ -56,10 +54,12 @@
 
 add_executable(${PROJECT_NAME} ${SOURCES})
 
+# WIN32_EXECUTABLE controls whether the CMD window is hidden
 set_target_properties(${PROJECT_NAME} PROPERTIES
     AUTOUIC 0
     AUTOMOC 1
     AUTORCC 0
+    WIN32_EXECUTABLE true
 )
 
 # link in Qt, the PdWidgets and the PdWidgets QML files

=== qml/de/igh/pd/CMakeLists.txt ===
--- 
+++ 
@@ -9,6 +9,8 @@
     FontAwesome.otf
     qmldir
     Sprintf.js
+    LoginDialog.qml
+    Pd.qml
     PdBar.qml
     PdCheckBox.qml
     PdComboBox.qml
@@ -30,7 +32,11 @@
     PdTouchEdit.qml
     TouchEdit.qml
     TouchEdit_2_1.qml
+    TouchEdit_2_3.qml
     TouchEditDialog.qml
+    TouchEditDialog_2_2.qml
+    TouchEditDialog_2_3.qml
+    TouchEditNumpad.qml
 DESTINATION "${QML_DIR}/${QML_PATH}")
 
 install(DIRECTORY

=== debian/rules ===
--- 
+++ 
@@ -12,6 +12,8 @@
 DPKG_EXPORT_BUILDFLAGS = 1
 include /usr/share/dpkg/default.mk
 
+PDQMLWIDGETS_VERSION=`dpkg-parsechangelog --show-field Version | cut -d - -f 1`
+
 # see FEATURE AREAS in dpkg-buildflags(1)
 #export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
@@ -25,6 +27,8 @@
 %:
 	dh $@ --parallel
 
+override_dh_auto_configure:
+	dh_auto_configure -- -DVERSION_HASH=${PDQMLWIDGETS_VERSION}
 
 .PHONY:
 	override_dh_strip
@@ -38,8 +42,3 @@
 override_dh_shlibdeps:
 	dh_shlibdeps -l $(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/
 
-
-
-
-
-
